import edu.princeton.cs.algs4.DirectedEdge;
import edu.princeton.cs.algs4.EdgeWeightedDigraph;
import edu.princeton.cs.algs4.In;
import edu.princeton.cs.algs4.IndexMinPQ;
import edu.princeton.cs.algs4.StdOut;

public class Dijkstras {
    private double[] distTo; // distTo[v] = distance of shortest s->v path
    private DirectedEdge[] edgeTo; // edgeTo[v] = last edge on shortest s->v path
    private IndexMinPQ<Double> pq; // priority queue of vertices
    
    // s is the source node
    public Dijkstras(EdgeWeightedDigraph G, int s) {
        // TODO: implement Dijkstra's

        // initialize data structures

        // initialize distances

        // run algorithm
    }

    /**
     * Returns the length of a shortest path from the source vertex s to
     * vertex v.
     */
    public double distTo(int v) {
        return distTo[v];
    }

    /**
     * Returns true if there is a path from the source vertex s to vertex v.
     */
    public boolean hasPathTo(int v) {
        return distTo[v] < Double.POSITIVE_INFINITY;
    }

    /**
     * Returns a shortest path from the source vertex s to vertex v.
     */
    public Iterable<DirectedEdge> pathTo(int v) {
        if (!hasPathTo(v))
            return null;
        // TODO
        return null;
    }

    public static void main(String[] args) {
        In in = new In("tinyEWD.txt");
        EdgeWeightedDigraph G = new EdgeWeightedDigraph(in);
        int s = 0;

        // compute shortest paths
        Dijkstras sp = new Dijkstras(G, s);

        // print shortest path
        for (int t = 0; t < G.V(); t++) {
            if (sp.hasPathTo(t)) {
                StdOut.printf("%d to %d (%.2f)  ", s, t, sp.distTo(t));
                for (DirectedEdge e : sp.pathTo(t)) {
                    StdOut.print(e + "   ");
                }
                StdOut.println();
            } else {
                StdOut.printf("%d to %d         no path\n", s, t);
            }
        }
    }

    /**
     * Expected output:
     * 0 to 0 (0.00)  
     * 0 to 1 (1.05)  0->4  0.38   4->5  0.35   5->1  0.32   
     * 0 to 2 (0.26)  0->2  0.26   
     * 0 to 3 (0.99)  0->2  0.26   2->7  0.34   7->3  0.39   
     * 0 to 4 (0.38)  0->4  0.38   
     * 0 to 5 (0.73)  0->4  0.38   4->5  0.35   
     * 0 to 6 (1.51)  0->2  0.26   2->7  0.34   7->3  0.39   3->6  0.52   
     * 0 to 7 (0.60)  0->2  0.26   2->7  0.34
     */
}